<!doctype html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="robots" content="noindex" />
    <title>Content Manager</title>
  </head>

  <body>
    <!-- Include the script that builds the page and powers Decap CMS -->
    <script src="https://unpkg.com/decap-cms@^3.0.0/dist/decap-cms.js"></script>
    <script>
      function convertToKebabCase(slug) {
        return slug
          .replace(/\//g, '-')
          .toLowerCase()
          .replace(/[^a-z0-9\-]+/g, '-')
          .replace(/^-+|-+$/g, '');
      }
      CMS.registerEventListener({
        name: 'preSave',
        handler: ({ entry }) => {
          // Logic needed for blog post auto fills
          if (entry.get('collection').includes('blogPost')) {
            const data = entry.get('data');
            let content = data.get('content');
            let seo = data.get('seo');
            let config = data.get('config');
            const title = content.get('title');
            const description = content.get('description');
            if (!config.get('slug')) {
              config = data.get('config').set('slug', convertToKebabCase(title));
            }
            if (!seo.get('title')) {
              seo = data.get('seo').set('title', title).set('description', description);
            }

            return entry.get('data').set('content', content).set('config', config).set('seo', seo);
          }
          return entry;
        },
      });
    </script>
  </body>
</html>
